import * as Stmt from '../parser/stmt';
import { FoldingRange } from 'vscode-languageserver';
import { Token } from '../entities/token';
import { TreeTraverse } from '../parser/treeTraverse';
import { IScript } from '../parser/types';
/**
 * A service for identifying foldable regions inside a kerboscript
 */
export declare class FoldableService extends TreeTraverse {
    /**
     * result of the scan
     */
    private result;
    /**
     * Construct a foldable service
     */
    constructor();
    /**
     * Find foldable regions within a document info
     * @param script the script ast
     * @param regions the region token throughout the script
     */
    findRegions(script: IScript, regions: Token[]): FoldingRange[];
    /**
     * Visit block statements to identify when folding regions are present
     * @param stmt block statement
     */
    visitBlock(stmt: Stmt.Block): void;
    /**
     * What are the foldable regions within this document using `\\ #region` and `\\ #endregion`
     * @param regions regions tokens
     */
    private foldableRegions;
}
