import { NotificationHandler } from 'vscode-jsonrpc';
import { DidChangeTextDocumentParams, DidOpenTextDocumentParams, DidCloseTextDocumentParams, TextDocument } from 'vscode-languageserver';
import { DocumentLoader } from '../../utilities/documentLoader';
import { DocumentService } from '../../services/documentService';
export declare const createMockDocConnection: () => {
    changeDoc: Maybe<NotificationHandler<DidChangeTextDocumentParams>>;
    openDoc: Maybe<NotificationHandler<DidOpenTextDocumentParams>>;
    closeDoc: Maybe<NotificationHandler<DidCloseTextDocumentParams>>;
    onDidChangeTextDocument(handler: NotificationHandler<DidChangeTextDocumentParams>): void;
    onDidCloseTextDocument(handler: NotificationHandler<DidCloseTextDocumentParams>): void;
    onDidOpenTextDocument(handler: NotificationHandler<DidOpenTextDocumentParams>): void;
    callChange(params: DidChangeTextDocumentParams): void;
    callOpen(params: DidOpenTextDocumentParams): void;
    callClose(params: DidCloseTextDocumentParams): void;
};
export declare const createMockUriResponse: (files: Map<string, string>) => DocumentLoader;
export declare const createMockDocumentService: (documents: Map<string, TextDocument>, volume0: string) => DocumentService;
