"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const typeGuards_1 = require("../../utilities/typeGuards");
const pathResolver_1 = require("../../utilities/pathResolver");
exports.createMockDocConnection = () => ({
    changeDoc: undefined,
    openDoc: undefined,
    closeDoc: undefined,
    onDidChangeTextDocument(handler) {
        this.changeDoc = handler;
    },
    onDidCloseTextDocument(handler) {
        this.closeDoc = handler;
    },
    onDidOpenTextDocument(handler) {
        this.openDoc = handler;
    },
    callChange(params) {
        if (this.changeDoc) {
            this.changeDoc(params);
        }
    },
    callOpen(params) {
        if (this.openDoc) {
            this.openDoc(params);
        }
    },
    callClose(params) {
        if (this.closeDoc) {
            this.closeDoc(params);
        }
    },
});
exports.createMockUriResponse = (files) => {
    return {
        load(path) {
            const document = files.get(path);
            if (!typeGuards_1.empty(document)) {
                return Promise.resolve(document);
            }
            return Promise.reject();
        },
        loadDirectory(_) { return __asyncGenerator(this, arguments, function* loadDirectory_1() { }); },
    };
};
exports.createMockDocumentService = (documents, volume0) => {
    const resolver = new pathResolver_1.PathResolver(volume0);
    return {
        ready() {
            return true;
        },
        setVolume0Uri(uri) {
            return __awaiter(this, void 0, void 0, function* () {
                resolver.volume0Uri = uri;
                return Promise.resolve();
            });
        },
        getDocument(uri) {
            return documents.get(uri);
        },
        getAllDocuments() {
            return [...documents.values()];
        },
        loadDocumentFromScript(location, runPath) {
            return __awaiter(this, void 0, void 0, function* () {
                const uri = resolver.resolveUri(location, runPath);
                return uri && documents.get(uri.toString());
            });
        },
        loadDocument(uri) {
            return __awaiter(this, void 0, void 0, function* () {
                return Promise.resolve(documents.get(uri));
            });
        },
        onChange(_) { },
        onClose(_) { },
    };
};
//# sourceMappingURL=mockServices.js.map