"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const enumerator_1 = require("./enumerator");
const constants_1 = require("../../../utilities/constants");
const scalar_1 = require("../primitives/scalar");
const boolean_1 = require("../primitives/boolean");
const string_1 = require("../primitives/string");
const void_1 = require("../primitives/void");
const serializeableStructure_1 = require("../primitives/serializeableStructure");
exports.enumerableType = typeCreators_1.createParametricType('enumerable', ['T']);
exports.enumerableType.addSuper(typeCreators_1.noMap(serializeableStructure_1.serializableType));
const containsSuffix = typeCreators_1.createParametricArgSuffixType('contains', ['T'], boolean_1.booleanType, 'T');
const enumeratorSuffix = typeCreators_1.createParametricArgSuffixType(constants_1.iterator, ['T'], enumerator_1.enumeratorType);
const reverseEnumeratorSuffix = typeCreators_1.createParametricArgSuffixType('reverseIterator', ['T'], enumerator_1.enumeratorType);
exports.enumerableType.addSuffixes(typeCreators_1.mapTypes(exports.enumerableType, containsSuffix), typeCreators_1.mapTypes(exports.enumerableType, enumeratorSuffix), typeCreators_1.mapTypes(exports.enumerableType, reverseEnumeratorSuffix), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('length', scalar_1.integerType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('empty', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('dump', string_1.stringType)));
exports.collectionType = typeCreators_1.createParametricType('collection', ['T']);
exports.collectionType.addSuper(typeCreators_1.mapTypes(exports.collectionType, exports.enumerableType));
exports.collectionType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createArgSuffixType('clear', void_1.voidType)));
//# sourceMappingURL=enumerable.js.map