"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const vector_1 = require("./vector");
const serializeableStructure_1 = require("../primitives/serializeableStructure");
const typeCreators_1 = require("../../typeCreators");
const scalar_1 = require("../primitives/scalar");
const operator_1 = require("../../types/operator");
const types_1 = require("../../types");
const boolean_1 = require("../primitives/boolean");
const direction_1 = require("./direction");
let set = false;
exports.collectionInitializer = () => {
    if (set) {
        return;
    }
    set = true;
    vector_1.vectorType.addSuper(typeCreators_1.noMap(serializeableStructure_1.serializableType));
    vector_1.vectorType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSetSuffixType('x', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('y', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('z', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('mag', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('vec', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('normalized', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('sqrMagnitude', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('direction', scalar_1.scalarType)));
    vector_1.vectorType.addOperators(new operator_1.Operator(vector_1.vectorType, types_1.OperatorKind.plus, vector_1.vectorType, vector_1.vectorType), new operator_1.Operator(vector_1.vectorType, types_1.OperatorKind.subtract, vector_1.vectorType, vector_1.vectorType), new operator_1.Operator(vector_1.vectorType, types_1.OperatorKind.multiply, scalar_1.scalarType, vector_1.vectorType), new operator_1.Operator(vector_1.vectorType, types_1.OperatorKind.multiply, vector_1.vectorType, scalar_1.scalarType), new operator_1.Operator(vector_1.vectorType, types_1.OperatorKind.divide, vector_1.vectorType, scalar_1.scalarType), new operator_1.Operator(vector_1.vectorType, types_1.OperatorKind.equal, boolean_1.booleanType, vector_1.vectorType), new operator_1.Operator(vector_1.vectorType, types_1.OperatorKind.notEqual, boolean_1.booleanType, vector_1.vectorType), new operator_1.Operator(vector_1.vectorType, types_1.OperatorKind.negate, vector_1.vectorType));
    vector_1.vectorType.addCoercion(direction_1.directionType);
    direction_1.directionType.addSuper(typeCreators_1.noMap(serializeableStructure_1.serializableType));
    direction_1.directionType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('pitch', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('yaw', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('roll', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('foreVector', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('vector', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('topVector', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('upVector', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('starVector', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('rightVector', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('inverse', direction_1.directionType)));
    direction_1.directionType.addOperators(new operator_1.Operator(direction_1.directionType, types_1.OperatorKind.multiply, direction_1.directionType, direction_1.directionType), new operator_1.Operator(direction_1.directionType, types_1.OperatorKind.multiply, vector_1.vectorType, vector_1.vectorType), new operator_1.Operator(direction_1.directionType, types_1.OperatorKind.plus, direction_1.directionType, direction_1.directionType), new operator_1.Operator(direction_1.directionType, types_1.OperatorKind.plus, vector_1.vectorType, vector_1.vectorType), new operator_1.Operator(direction_1.directionType, types_1.OperatorKind.subtract, direction_1.directionType, direction_1.directionType), new operator_1.Operator(direction_1.directionType, types_1.OperatorKind.equal, vector_1.vectorType, vector_1.vectorType), new operator_1.Operator(direction_1.directionType, types_1.OperatorKind.notEqual, vector_1.vectorType, vector_1.vectorType), new operator_1.Operator(direction_1.directionType, types_1.OperatorKind.negate, direction_1.directionType));
};
//# sourceMappingURL=initialize.js.map