"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const structure_1 = require("../primitives/structure");
const void_1 = require("../primitives/void");
const userList_1 = require("./userList");
const boolean_1 = require("../primitives/boolean");
const scalar_1 = require("../primitives/scalar");
const serializeableStructure_1 = require("../primitives/serializeableStructure");
const indexer_1 = require("../../types/indexer");
const callSignature_1 = require("../../types/callSignature");
exports.lexiconType = typeCreators_1.createType('lexicon');
exports.lexiconType.addSuper(typeCreators_1.noMap(serializeableStructure_1.serializableType));
exports.lexiconType.addIndexer(typeCreators_1.noMap(new indexer_1.Indexer(new callSignature_1.CallSignature([structure_1.structureType], structure_1.structureType), new Map())));
exports.lexiconType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createArgSuffixType('clear', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('keys', userList_1.userListType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('hasKey', boolean_1.booleanType, structure_1.structureType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('hasValue', boolean_1.booleanType, structure_1.structureType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('values', userList_1.userListType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('copy', exports.lexiconType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('length', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('remove', boolean_1.booleanType, structure_1.structureType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('add', void_1.voidType, structure_1.structureType, structure_1.structureType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('caseSensitive', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('case', boolean_1.booleanType)));
//# sourceMappingURL=lexicon.js.map