"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const void_1 = require("../primitives/void");
const scalar_1 = require("../primitives/scalar");
const enumerable_1 = require("./enumerable");
const string_1 = require("../primitives/string");
exports.listType = typeCreators_1.createParametricType('list', ['T']);
exports.listType.addSuper(typeCreators_1.mapTypes(exports.listType, enumerable_1.collectionType));
const indexer = typeCreators_1.createParametricIndexer(['T'], scalar_1.scalarType, 'T');
exports.listType.addIndexer(typeCreators_1.mapTypes(exports.listType, indexer));
const addSuffix = typeCreators_1.createParametricArgSuffixType('add', ['T'], void_1.voidType, 'T');
const insertSuffix = typeCreators_1.createParametricArgSuffixType('insert', ['T'], void_1.voidType, scalar_1.scalarType, 'T');
const indexOfSuffix = typeCreators_1.createParametricArgSuffixType('indexOf', ['T'], scalar_1.integerType, 'T');
const findSuffix = typeCreators_1.createParametricArgSuffixType('find', ['T'], scalar_1.integerType, 'T');
const lastIndexOfSuffix = typeCreators_1.createParametricArgSuffixType('lastIndexOf', ['T'], scalar_1.integerType, 'T');
const findLastSuffix = typeCreators_1.createParametricArgSuffixType('findLast', ['T'], scalar_1.integerType, 'T');
const subListSuffix = typeCreators_1.createParametricArgSuffixType('sublist', ['T'], exports.listType, scalar_1.scalarType, scalar_1.scalarType);
const copySuffix = typeCreators_1.createParametricArgSuffixType('copy', ['T'], exports.listType);
exports.listType.addSuffixes(typeCreators_1.mapTypes(exports.listType, copySuffix), typeCreators_1.mapTypes(exports.listType, addSuffix), typeCreators_1.mapTypes(exports.listType, insertSuffix), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('remove', void_1.voidType, scalar_1.scalarType)), typeCreators_1.mapTypes(exports.listType, subListSuffix), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('join', string_1.stringType, string_1.stringType)), typeCreators_1.mapTypes(exports.listType, indexOfSuffix), typeCreators_1.mapTypes(exports.listType, findSuffix), typeCreators_1.mapTypes(exports.listType, lastIndexOfSuffix), typeCreators_1.mapTypes(exports.listType, findLastSuffix));
//# sourceMappingURL=list.js.map