"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const enumerable_1 = require("./enumerable");
const void_1 = require("../primitives/void");
exports.queueType = typeCreators_1.createParametricType('queue', ['T']);
exports.queueType.addSuper(typeCreators_1.mapTypes(exports.queueType, enumerable_1.enumerableType));
const copySuffix = typeCreators_1.createParametricArgSuffixType('copy', ['T'], exports.queueType);
const pushSuffix = typeCreators_1.createParametricArgSuffixType('push', ['T'], void_1.voidType, 'T');
const popSuffix = typeCreators_1.createParametricArgSuffixType('pop', ['T'], 'T');
const peekSuffix = typeCreators_1.createParametricArgSuffixType('peek', ['T'], 'T');
exports.queueType.addSuffixes(typeCreators_1.mapTypes(exports.queueType, copySuffix), typeCreators_1.mapTypes(exports.queueType, pushSuffix), typeCreators_1.mapTypes(exports.queueType, popSuffix), typeCreators_1.mapTypes(exports.queueType, peekSuffix), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('clear', void_1.voidType)));
//# sourceMappingURL=queue.js.map