"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const enumerable_1 = require("./enumerable");
const void_1 = require("../primitives/void");
exports.stackType = typeCreators_1.createParametricType('stack', ['T']);
exports.stackType.addSuper(typeCreators_1.mapTypes(exports.stackType, enumerable_1.enumerableType));
const copySuffix = typeCreators_1.createParametricArgSuffixType('copy', ['T'], exports.stackType);
const pushSuffix = typeCreators_1.createParametricArgSuffixType('push', ['T'], void_1.voidType, 'T');
const popSuffix = typeCreators_1.createParametricArgSuffixType('pop', ['T'], 'T');
const peekSuffix = typeCreators_1.createParametricArgSuffixType('peek', ['T'], 'T');
exports.stackType.addSuffixes(typeCreators_1.mapTypes(exports.stackType, copySuffix), typeCreators_1.mapTypes(exports.stackType, pushSuffix), typeCreators_1.mapTypes(exports.stackType, popSuffix), typeCreators_1.mapTypes(exports.stackType, peekSuffix), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('clear', void_1.voidType)));
//# sourceMappingURL=stack.js.map