"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const void_1 = require("../primitives/void");
const enumerable_1 = require("./enumerable");
const boolean_1 = require("../primitives/boolean");
exports.uniqueSetType = typeCreators_1.createParametricType('uniqueSet', ['T']);
exports.uniqueSetType.addSuper(typeCreators_1.mapTypes(exports.uniqueSetType, enumerable_1.collectionType));
const copySuffix = typeCreators_1.createParametricArgSuffixType('copy', ['T'], exports.uniqueSetType);
const addSuffix = typeCreators_1.createParametricArgSuffixType('add', ['T'], void_1.voidType, 'T');
const removeSuffix = typeCreators_1.createParametricArgSuffixType('remove', ['T'], boolean_1.booleanType, 'T');
exports.uniqueSetType.addSuffixes(typeCreators_1.mapTypes(exports.uniqueSetType, copySuffix), typeCreators_1.mapTypes(exports.uniqueSetType, addSuffix), typeCreators_1.mapTypes(exports.uniqueSetType, removeSuffix));
//# sourceMappingURL=uniqueset.js.map