"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const structure_1 = require("./primitives/structure");
const scalar_1 = require("./primitives/scalar");
const constantType_1 = require("../types/constantType");
exports.gType = new constantType_1.ConstantType('g', 6.67384e-11, { get: true, set: false }, new Map(), 0 /* basic */);
exports.gType.addSuper(typeCreators_1.noMap(scalar_1.doubleType));
exports.eType = new constantType_1.ConstantType('e', Math.E, { get: true, set: false }, new Map(), 0 /* basic */);
exports.eType.addSuper(typeCreators_1.noMap(scalar_1.doubleType));
exports.piType = new constantType_1.ConstantType('pi', Math.PI, { get: true, set: false }, new Map(), 0 /* basic */);
exports.piType.addSuper(typeCreators_1.noMap(scalar_1.doubleType));
exports.cType = new constantType_1.ConstantType('c', 299792458.0, { get: true, set: false }, new Map(), 0 /* basic */);
exports.cType.addSuper(typeCreators_1.noMap(scalar_1.doubleType));
exports.atmToKpaType = new constantType_1.ConstantType('atmtokpa', 101.325, { get: true, set: false }, new Map(), 0 /* basic */);
exports.atmToKpaType.addSuper(typeCreators_1.noMap(scalar_1.doubleType));
exports.kpaToAtmType = new constantType_1.ConstantType('kpatoatm', 0.00986923266716012830002467308167, { get: true, set: false }, new Map(), 0 /* basic */);
exports.kpaToAtmType.addSuper(typeCreators_1.noMap(scalar_1.doubleType));
exports.degToRadType = new constantType_1.ConstantType('degtorad', 0.01745329251994329576923690768489, { get: true, set: false }, new Map(), 0 /* basic */);
exports.degToRadType.addSuper(typeCreators_1.noMap(scalar_1.doubleType));
exports.radToDegType = new constantType_1.ConstantType('radtodeg', 57.295779513082320876798154814105, { get: true, set: false }, new Map(), 0 /* basic */);
exports.radToDegType.addSuper(typeCreators_1.noMap(scalar_1.doubleType));
exports.avogadroType = new constantType_1.ConstantType('avogadro', 6.02214076e23, { get: true, set: false }, new Map(), 0 /* basic */);
exports.avogadroType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.boltzmannType = new constantType_1.ConstantType('boltzmann', 1.380649e-23, { get: true, set: false }, new Map(), 0 /* basic */);
exports.boltzmannType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.idealGasType = new constantType_1.ConstantType('idealGas', 8.31446215324, { get: true, set: false }, new Map(), 0 /* basic */);
exports.idealGasType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.constantType = typeCreators_1.createType('constant');
exports.constantType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.constantType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType(exports.gType.name, exports.gType)), typeCreators_1.noMap(typeCreators_1.createSuffixType(exports.eType.name, exports.eType)), typeCreators_1.noMap(typeCreators_1.createSuffixType(exports.piType.name, exports.piType)), typeCreators_1.noMap(typeCreators_1.createSuffixType(exports.cType.name, exports.cType)), typeCreators_1.noMap(typeCreators_1.createSuffixType(exports.atmToKpaType.name, exports.atmToKpaType)), typeCreators_1.noMap(typeCreators_1.createSuffixType(exports.kpaToAtmType.name, exports.kpaToAtmType)), typeCreators_1.noMap(typeCreators_1.createSuffixType(exports.degToRadType.name, exports.degToRadType)), typeCreators_1.noMap(typeCreators_1.createSuffixType(exports.radToDegType.name, exports.radToDegType)));
//# sourceMappingURL=constant.js.map