"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const kosProcessorFields_1 = require("./kosProcessorFields");
const volume_1 = require("./io/volume");
const versionInfo_1 = require("./versionInfo");
const vesselTarget_1 = require("./orbital/vesselTarget");
const element_1 = require("./parts/element");
const messageQueue_1 = require("./communication/messageQueue");
exports.coreType = typeCreators_1.createType('core');
exports.coreType.addSuper(typeCreators_1.noMap(kosProcessorFields_1.kosProcessorFieldsType));
exports.coreType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('version', versionInfo_1.versionInfoType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('vessel', vesselTarget_1.vesselTargetType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('element', element_1.elementType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('currentVolume', volume_1.volumeType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('messages', messageQueue_1.messageQueueType)));
//# sourceMappingURL=core.js.map