"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const structure_1 = require("../primitives/structure");
const rgba_1 = require("../rgba");
const widgetStyle_1 = require("./widgetStyle");
const string_1 = require("../primitives/string");
const boolean_1 = require("../primitives/boolean");
exports.widgetSkinType = typeCreators_1.createType('skin');
exports.widgetSkinType.addSuper(typeCreators_1.noMap(structure_1.structureType));
const builtIns = [
    'box',
    'button',
    'horizontalScrollbar',
    'horizontalScrollbarLeftButton',
    'horizontalScrollbarRightButton',
    'horizontalScrollbarThumb',
    'horizontalSlider',
    'horizontalSliderThumb',
    'verticalScrollbar',
    'verticalScrollbarLeftButton',
    'verticalScrollbarRightButton',
    'verticalScrollbarThumb',
    'verticalSlider',
    'verticalSliderThumb',
    'label',
    'scrollView',
    'textArea',
    'textField',
    'toggle',
    'window',
];
exports.widgetSkinType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSetSuffixType('font', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('selectionColor', rgba_1.rgbaType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('add', widgetStyle_1.widgetStyleType, string_1.stringType, widgetStyle_1.widgetStyleType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('get', widgetStyle_1.widgetStyleType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('has', boolean_1.booleanType, string_1.stringType)), ...builtIns.map(builtIn => typeCreators_1.noMap(typeCreators_1.createSetSuffixType(builtIn, widgetStyle_1.widgetStyleType))));
//# sourceMappingURL=widgetSkin.js.map