"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const structure_1 = require("../primitives/structure");
const volumeDirectory_1 = require("./volumeDirectory");
const volumneFile_1 = require("./volumneFile");
const lexicon_1 = require("../collections/lexicon");
const scalar_1 = require("../primitives/scalar");
const string_1 = require("../primitives/string");
const boolean_1 = require("../primitives/boolean");
exports.volumeType = typeCreators_1.createType('volume');
exports.volumeType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.volumeType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('freespace', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('capacity', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('name', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('renameable', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('powerrequirement', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('root', volumeDirectory_1.volumeDirectoryType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('exists', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('files', lexicon_1.lexiconType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('create', string_1.stringType, volumneFile_1.volumeFileType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('createDir', string_1.stringType, volumeDirectory_1.volumeDirectoryType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('open', string_1.stringType, structure_1.structureType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('delete', string_1.stringType, boolean_1.booleanType)));
//# sourceMappingURL=volume.js.map