"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const structure_1 = require("./primitives/structure");
const uniqueset_1 = require("./collections/uniqueset");
const delegate_1 = require("./primitives/delegate");
const loadDistance_1 = require("./loadDistance");
const craftTemplate_1 = require("./craftTemplate");
const timewarp_1 = require("./timewarp");
const void_1 = require("./primitives/void");
const boolean_1 = require("./primitives/boolean");
const string_1 = require("./primitives/string");
const scalar_1 = require("./primitives/scalar");
const vesselTarget_1 = require("./orbital/vesselTarget");
const list_1 = require("./collections/list");
exports.kUniverseType = typeCreators_1.createType('kuniverse');
exports.kUniverseType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.kUniverseType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('canRevert', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('canRevertToLaunch', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('canRevertToEditor', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('revertToLuanch', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('revertToEditor', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('canQuickSave', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('pause', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('quickSave', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('quickLoad', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('quickSaveTo', void_1.voidType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('quickLoadFrom', void_1.voidType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('quickSaveList', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('originEditor', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('defaultLoadDistance', loadDistance_1.loadDistanceType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('activeVessel', vesselTarget_1.vesselTargetType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('forceSetActiveVessel', void_1.voidType, vesselTarget_1.vesselTargetType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('forceActive', void_1.voidType, vesselTarget_1.vesselTargetType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('hoursPerDay', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('debugLog', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('getCraft', craftTemplate_1.craftTemplateType, string_1.stringType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('launchCraft', void_1.voidType, craftTemplate_1.craftTemplateType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('launchCraftFrom', void_1.voidType, craftTemplate_1.craftTemplateType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('craftList', list_1.listType.apply(craftTemplate_1.craftTemplateType))), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('switchVesselWatchers', uniqueset_1.uniqueSetType.apply(delegate_1.delegateType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('timewarp', timewarp_1.timeWarpType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('realWorldTime', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('realTime', scalar_1.scalarType)));
//# sourceMappingURL=kUniverse.js.map