"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const structure_1 = require("./primitives/structure");
const vector_1 = require("./collections/vector");
const string_1 = require("./primitives/string");
const scalar_1 = require("./primitives/scalar");
const boolean_1 = require("./primitives/boolean");
const bodyTarget_1 = require("./orbital/bodyTarget");
exports.orbitInfoType = typeCreators_1.createType('orbitInfo');
exports.orbitInfoType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.orbitInfoType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('name', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('apoapsis', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('periapsis', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('body', bodyTarget_1.bodyTargetType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('period', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('inclination', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('eccentricity', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('semiMajorAxis', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('semiMinorAxis', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('lan', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('longitudeOfAscendingNode', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('argumentOfPeriapsis', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('trueAnomaly', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('meanAnomalyAtEpoch', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('epoch', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('transition', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('position', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('nextPatch', exports.orbitInfoType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('hasNextPatch', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('nextPatchEta', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('vStateVector', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('rStateVector', vector_1.vectorType)));
//# sourceMappingURL=orbitInfo.js.map