"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const decoupler_1 = require("./decoupler");
const scalar_1 = require("../primitives/scalar");
const string_1 = require("../primitives/string");
const boolean_1 = require("../primitives/boolean");
const void_1 = require("../primitives/void");
const direction_1 = require("../collections/direction");
const vector_1 = require("../collections/vector");
const uniqueset_1 = require("../collections/uniqueset");
const userDelegate_1 = require("../userDelegate");
exports.dockingPortType = typeCreators_1.createType('dockingPort');
exports.dockingPortType.addSuper(typeCreators_1.noMap(decoupler_1.decouplerType));
exports.dockingPortType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('acquireRange', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('acquireForce', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('acquireTorque', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('reengagedDistance', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('dockedShipName', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('state', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('targetTable', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('undock', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('target', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('portFacing', direction_1.directionType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('nodePosition', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('nodeType', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('dockWatchers', uniqueset_1.uniqueSetType.apply(userDelegate_1.userDelegateType))), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('undockWatchers', uniqueset_1.uniqueSetType.apply(userDelegate_1.userDelegateType))));
//# sourceMappingURL=dockingPort.js.map