"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const structure_1 = require("../primitives/structure");
const list_1 = require("../collections/list");
const string_1 = require("../primitives/string");
const vesselTarget_1 = require("../orbital/vesselTarget");
const part_1 = require("./part");
const dockingPort_1 = require("./dockingPort");
const aggregateResource_1 = require("./aggregateResource");
exports.elementType = typeCreators_1.createType('element');
exports.elementType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.elementType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('name', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('uid', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('vessel', vesselTarget_1.vesselTargetType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('parts', list_1.listType.apply(part_1.partType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('dockingPorts', list_1.listType.apply(dockingPort_1.dockingPortType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('resources', list_1.listType.apply(aggregateResource_1.aggregateResourceType))));
//# sourceMappingURL=element.js.map