"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../../typeCreators");
const list_1 = require("../collections/list");
const void_1 = require("../primitives/void");
const string_1 = require("../primitives/string");
const scalar_1 = require("../primitives/scalar");
const boolean_1 = require("../primitives/boolean");
const part_1 = require("./part");
const gimbal_1 = require("./gimbal");
exports.engineType = typeCreators_1.createType('engine');
exports.engineType.addSuper(typeCreators_1.noMap(part_1.partType));
exports.engineType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createArgSuffixType('activate', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('deactivate', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('thrustLimit', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('maxThrust', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('thrust', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('fuelFlow', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('isp', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('vIsp', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('vacuumisp', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('slIsp', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('seaLevelIsp', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('flameOut', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('ignition', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('allowsRestart', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('allowsShutdown', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('throttleLock', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('ispAt', scalar_1.scalarType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('maxThrustAt', scalar_1.scalarType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('availableThrust', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('availableThrustAt', scalar_1.scalarType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('multiMode', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('modes', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('mode', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('toggleMode', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('primaryMode', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('autoSwitch', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('hasGimbal', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('gimbal', gimbal_1.gimbalType)));
//# sourceMappingURL=engine.js.map