"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const part_1 = require("./part");
const structure_1 = require("../primitives/structure");
const typeCreators_1 = require("../../typeCreators");
const void_1 = require("../primitives/void");
const string_1 = require("../primitives/string");
const boolean_1 = require("../primitives/boolean");
const scalar_1 = require("../primitives/scalar");
const direction_1 = require("../collections/direction");
const vector_1 = require("../collections/vector");
const list_1 = require("../collections/list");
const resource_1 = require("./resource");
const vesselTarget_1 = require("../orbital/vesselTarget");
const partModule_1 = require("./partModule");
const types_1 = require("../../types");
const bounds_1 = require("./bounds");
const operator_1 = require("../../types/operator");
let set = false;
exports.partInitializer = () => {
    if (set) {
        return;
    }
    set = true;
    // -------------------- part ---------------------------
    part_1.partType.addSuper(typeCreators_1.noMap(structure_1.structureType));
    part_1.partType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createArgSuffixType('controlFrom', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('name', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('fuelCrossFeed', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('title', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('stage', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('cid', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('uid', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('rotation', direction_1.directionType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('position', vector_1.vectorType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('tag', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('facing', direction_1.directionType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('bounds', bounds_1.boundsType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('resources', list_1.listType.apply(resource_1.resourceType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('targetable', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('ship', vesselTarget_1.vesselTargetType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('hasModule', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('getModule', partModule_1.partModuleType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('getModulesByIndex', partModule_1.partModuleType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('modules', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('allModules', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('parent', structure_1.structureType)), // TODO part | string
    typeCreators_1.noMap(typeCreators_1.createSuffixType('decoupler', structure_1.structureType)), // TODO part | string
    typeCreators_1.noMap(typeCreators_1.createSuffixType('separator', structure_1.structureType)), // TODO part | string
    typeCreators_1.noMap(typeCreators_1.createSuffixType('decoupledIn', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('separatedIn', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('hasParent', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('children', list_1.listType.apply(part_1.partType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('dryMass', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('mass', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('wetMass', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('hasPhysics', boolean_1.booleanType)));
    part_1.partType.addOperators(new operator_1.Operator(part_1.partType, types_1.OperatorKind.equal, boolean_1.booleanType, part_1.partType), new operator_1.Operator(part_1.partType, types_1.OperatorKind.notEqual, boolean_1.booleanType, part_1.partType));
    // -------------------- partmodule ---------------------------
    partModule_1.partModuleType.addSuper(typeCreators_1.noMap(structure_1.structureType));
    partModule_1.partModuleType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('name', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('part', part_1.partType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('allFields', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('allFieldNames', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('hasField', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('allEvents', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('allEventNames', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('hasEvent', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('allActions', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('allActionNames', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('hasAction', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('getField', structure_1.structureType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('setField', void_1.voidType, structure_1.structureType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('doEvent', void_1.voidType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('doAction', void_1.voidType, string_1.stringType, boolean_1.booleanType)));
};
//# sourceMappingURL=initialize.js.map