"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const structure_1 = require("./structure");
const typeCreators_1 = require("../../typeCreators");
const string_1 = require("./string");
const boolean_1 = require("./boolean");
const serializeableStructure_1 = require("./serializeableStructure");
const primitives_1 = require("./primitives");
const scalar_1 = require("./scalar");
const list_1 = require("../collections/list");
const delegate_1 = require("./delegate");
const types_1 = require("../../types");
const constants_1 = require("../../../utilities/constants");
const enumerator_1 = require("../collections/enumerator");
const operator_1 = require("../../types/operator");
const indexer_1 = require("../../types/indexer");
const callSignature_1 = require("../../types/callSignature");
let set = false;
exports.primitiveInitializer = () => {
    if (set) {
        return;
    }
    set = true;
    // ------------------ structure ---------------------------
    structure_1.structureType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createArgSuffixType('toString', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('hasSuffix', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('suffixNames', list_1.listType.apply(string_1.stringType))), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('isSerializable', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('typeName', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('isType', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('inheritance', string_1.stringType)));
    // ------------------ serializable structure ---------------------------
    serializeableStructure_1.serializableType.addSuper(typeCreators_1.noMap(structure_1.structureType));
    // ------------------ primitives ---------------------------
    primitives_1.primitiveType.addSuper(typeCreators_1.noMap(structure_1.structureType));
    // ------------------ string ---------------------------
    string_1.stringType.addOperators(new operator_1.Operator(string_1.stringType, types_1.OperatorKind.plus, string_1.stringType, string_1.stringType), new operator_1.Operator(string_1.stringType, types_1.OperatorKind.greaterThan, boolean_1.booleanType, string_1.stringType), new operator_1.Operator(string_1.stringType, types_1.OperatorKind.lessThan, boolean_1.booleanType, string_1.stringType), new operator_1.Operator(string_1.stringType, types_1.OperatorKind.greaterThanEqual, boolean_1.booleanType, string_1.stringType), new operator_1.Operator(string_1.stringType, types_1.OperatorKind.lessThanEqual, boolean_1.booleanType, string_1.stringType), new operator_1.Operator(string_1.stringType, types_1.OperatorKind.equal, boolean_1.booleanType, string_1.stringType), new operator_1.Operator(string_1.stringType, types_1.OperatorKind.notEqual, boolean_1.booleanType, string_1.stringType));
    string_1.stringType.addCoercion(structure_1.structureType);
    string_1.stringType.addSuper(typeCreators_1.noMap(primitives_1.primitiveType));
    string_1.stringType.addIndexer(typeCreators_1.noMap(new indexer_1.Indexer(new callSignature_1.CallSignature([scalar_1.scalarType], string_1.stringType), new Map())));
    string_1.stringType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createArgSuffixType('length', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('substring', string_1.stringType, scalar_1.scalarType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('contains', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('endsWith', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('findAt', scalar_1.scalarType, string_1.stringType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('insert', string_1.stringType, scalar_1.scalarType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('findLastAt', scalar_1.scalarType, string_1.stringType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('padLeft', string_1.stringType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('padRight', string_1.stringType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('remove', string_1.stringType, scalar_1.scalarType, scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('replace', string_1.stringType, string_1.stringType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('split', list_1.listType.apply(string_1.stringType), string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('startsWith', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('toLower', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('toUpper', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('trim', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('trimEnd', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('trimStart', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('matchesPattern', boolean_1.booleanType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createVarSuffixType('toNumber', scalar_1.scalarType, typeCreators_1.createVarType(structure_1.structureType))), typeCreators_1.noMap(typeCreators_1.createVarSuffixType('toScalar', scalar_1.scalarType, typeCreators_1.createVarType(structure_1.structureType))), typeCreators_1.noMap(typeCreators_1.createVarSuffixType('format', string_1.stringType, typeCreators_1.createVarType(structure_1.structureType))), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('indexOf', scalar_1.scalarType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('find', scalar_1.scalarType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('lastIndexOf', scalar_1.scalarType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('findLast', scalar_1.scalarType, string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType(constants_1.iterator, enumerator_1.enumeratorType.apply(string_1.stringType))));
    // ------------------ scalar ---------------------------
    scalar_1.scalarType.addOperators(new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.plus, scalar_1.scalarType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.subtract, scalar_1.scalarType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.multiply, scalar_1.scalarType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.divide, scalar_1.scalarType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.power, scalar_1.scalarType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.greaterThan, boolean_1.booleanType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.lessThan, boolean_1.booleanType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.greaterThanEqual, boolean_1.booleanType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.lessThanEqual, boolean_1.booleanType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.notEqual, boolean_1.booleanType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.equal, boolean_1.booleanType, scalar_1.scalarType), new operator_1.Operator(scalar_1.scalarType, types_1.OperatorKind.negate, scalar_1.scalarType));
    scalar_1.scalarType.addSuper(typeCreators_1.noMap(primitives_1.primitiveType));
    // ------------------ integer ---------------------------
    scalar_1.integerType.addSuper(typeCreators_1.noMap(scalar_1.scalarType));
    // ------------------ double ---------------------------
    scalar_1.doubleType.addSuper(typeCreators_1.noMap(scalar_1.scalarType));
    // ------------------ delegate ---------------------------
    delegate_1.delegateType.addSuper(typeCreators_1.noMap(structure_1.structureType));
    delegate_1.delegateType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createVarSuffixType('call', structure_1.structureType, typeCreators_1.createVarType(structure_1.structureType))), typeCreators_1.noMap(typeCreators_1.createVarSuffixType('bind', delegate_1.delegateType, typeCreators_1.createVarType(structure_1.structureType))), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('isdead', boolean_1.booleanType)));
    // ------------------ boolean ---------------------------
    boolean_1.booleanType.addOperators(new operator_1.Operator(boolean_1.booleanType, types_1.OperatorKind.notEqual, boolean_1.booleanType, boolean_1.booleanType), new operator_1.Operator(boolean_1.booleanType, types_1.OperatorKind.equal, boolean_1.booleanType, boolean_1.booleanType), new operator_1.Operator(boolean_1.booleanType, types_1.OperatorKind.and, boolean_1.booleanType, boolean_1.booleanType), new operator_1.Operator(boolean_1.booleanType, types_1.OperatorKind.or, boolean_1.booleanType, boolean_1.booleanType));
    boolean_1.booleanType.addCoercion(structure_1.structureType);
    boolean_1.booleanType.addSuper(typeCreators_1.noMap(primitives_1.primitiveType));
};
//# sourceMappingURL=initialize.js.map