"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const structure_1 = require("./primitives/structure");
const void_1 = require("./primitives/void");
const string_1 = require("./primitives/string");
const boolean_1 = require("./primitives/boolean");
exports.terminalInputType = typeCreators_1.createType('terminalInput');
exports.terminalInputType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.terminalInputType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('getChar', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('hasChar', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('clear', void_1.voidType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('backspace', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('return', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('enter', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('upcursorone', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('downcursorone', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('leftcursorone', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('rightcursorone', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('homecursor', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('endcursor', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('pageupcursor', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('pagedowncursor', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('deleteright', string_1.stringType)));
//# sourceMappingURL=terminalInput.js.map