"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const structure_1 = require("./primitives/structure");
const uniqueset_1 = require("./collections/uniqueset");
const terminalInput_1 = require("./terminalInput");
const scalar_1 = require("./primitives/scalar");
const boolean_1 = require("./primitives/boolean");
const userDelegate_1 = require("./userDelegate");
exports.terminalStructType = typeCreators_1.createType('terminalStruct');
exports.terminalStructType.addSuper(typeCreators_1.noMap(structure_1.structureType));
exports.terminalStructType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSetSuffixType('height', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('width', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('reverse', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('visualBeep', boolean_1.booleanType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('brightness', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('charWidth', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSetSuffixType('charHeight', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createArgSuffixType('resizeWatchers', uniqueset_1.uniqueSetType.apply(userDelegate_1.userDelegateType))), typeCreators_1.noMap(typeCreators_1.createSuffixType('input', terminalInput_1.terminalInputType)));
//# sourceMappingURL=terminalStruct.js.map