"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeCreators_1 = require("../typeCreators");
const scalar_1 = require("./primitives/scalar");
const string_1 = require("./primitives/string");
const serializeableStructure_1 = require("./primitives/serializeableStructure");
const types_1 = require("../types");
const boolean_1 = require("./primitives/boolean");
const operator_1 = require("../types/operator");
exports.timeSpanType = typeCreators_1.createType('timeSpan');
exports.timeSpanType.addSuper(typeCreators_1.noMap(serializeableStructure_1.serializableType));
exports.timeSpanType.addSuffixes(typeCreators_1.noMap(typeCreators_1.createSuffixType('year', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('day', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('hour', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('minute', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('second', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('seconds', scalar_1.scalarType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('clock', string_1.stringType)), typeCreators_1.noMap(typeCreators_1.createSuffixType('calendar', string_1.stringType)));
exports.timeSpanType.addOperators(
// +
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.plus, exports.timeSpanType, exports.timeSpanType), new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.plus, exports.timeSpanType, scalar_1.scalarType), 
// -
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.subtract, exports.timeSpanType, exports.timeSpanType), new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.subtract, exports.timeSpanType, scalar_1.scalarType), 
// *
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.multiply, exports.timeSpanType, scalar_1.scalarType), 
// /
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.divide, exports.timeSpanType, exports.timeSpanType), new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.divide, exports.timeSpanType, scalar_1.scalarType), 
// <
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.lessThan, boolean_1.booleanType, exports.timeSpanType), new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.lessThan, boolean_1.booleanType, scalar_1.scalarType), 
// >
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.greaterThan, boolean_1.booleanType, exports.timeSpanType), new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.greaterThan, boolean_1.booleanType, scalar_1.scalarType), 
// >=
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.greaterThanEqual, boolean_1.booleanType, exports.timeSpanType), new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.greaterThanEqual, boolean_1.booleanType, scalar_1.scalarType), 
// <=
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.lessThanEqual, boolean_1.booleanType, exports.timeSpanType), new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.lessThanEqual, boolean_1.booleanType, scalar_1.scalarType), 
// <>
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.notEqual, boolean_1.booleanType, exports.timeSpanType), 
// =
new operator_1.Operator(exports.timeSpanType, types_1.OperatorKind.equal, boolean_1.booleanType, exports.timeSpanType));
//# sourceMappingURL=timespan.js.map