import { Token } from '../entities/token';
import { TokenType } from '../entities/tokentypes';
import { OperatorKind, IType, IParametricType } from './types';
/**
 * This map token types to binary operator kinds
 */
export declare const binaryOperatorMap: Map<TokenType, OperatorKind>;
/**
 * This maps tokens types to unary operator kinds
 */
export declare const unaryOperatorMap: Map<TokenType, OperatorKind>;
/**
 * Retrieve the type of the follow token
 * @param token token to retrieve
 */
export declare const tokenTrackedType: (token: Token) => Maybe<IType>;
/**
 * Create a pass type parameter for generics with only one parameter
 * @param type the type to create a pass through
 * @param superType the super type to create a pass through
 */
export declare const passThroughTypeParameter: (type: IParametricType, superType: IParametricType) => Map<IParametricType, IParametricType>;
