"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const type_1 = require("./type");
/**
 * Represents a constant type, or a type with a fixed value
 */
class ConstantType extends type_1.Type {
    /**
     * Construct a constant type
     * @param name name of this constant type
     * @param value value of this constant type
     */
    constructor(name, value, access, typeArguments, kind, callSignature, typeTemplate) {
        super(name, access, typeArguments, kind, callSignature, typeTemplate);
        this.value = value;
    }
    /**
     * Create a type string from this type
     */
    toString() {
        return `${super.toString()} = ${this.value}`;
    }
}
exports.ConstantType = ConstantType;
//# sourceMappingURL=constantType.js.map