"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const type_1 = require("./type");
const typeGuards_1 = require("../../utilities/typeGuards");
class Indexer extends type_1.Type {
    constructor(callSignature, typeArgument) {
        super('Indexer', { get: true, set: true }, typeArgument, 3 /* indexer */, callSignature, undefined, false);
        this.kind = 3 /* indexer */;
    }
    toString() {
        const callSignature = this.getCallSignature();
        if (typeGuards_1.empty(callSignature)) {
            throw new Error('Indexer somehow has empty call signature');
        }
        const [index] = callSignature.params();
        const returns = callSignature.returns();
        return `[${index.toString()}] => ${returns.toString()}`;
    }
    apply(_) {
        return this;
    }
}
exports.Indexer = Indexer;
//# sourceMappingURL=indexer.js.map