"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeGuards_1 = require("../../utilities/typeGuards");
class Operator {
    /**
     * Construct and instance of an operator
     * @param firstOperand What is the first operand
     * @param operator what is the operator kind
     * @param otherOperand what else need to appear in this operation
     * @param returnType what is the return type of this operation
     */
    constructor(firstOperand, operator, returnType, otherOperand) {
        this.name = 'Operator';
        this.firstOperand = firstOperand;
        this.operator = operator;
        this.secondOperand = otherOperand;
        this.returnType = returnType;
    }
    /**
     * Is the operator a unary operator
     */
    isUnary() {
        return typeGuards_1.empty(this.secondOperand);
    }
}
exports.Operator = Operator;
//# sourceMappingURL=operator.js.map