import { IType, Access, TypeKind, ICallSignature, OperatorKind, IParametricType, IIndexer } from '../types';
import { Operator } from './operator';
import { TypeTracker } from '../../analysis/typeTracker';
export declare class VariadicType implements IType {
    readonly anyType: boolean;
    readonly name: string;
    readonly access: Access;
    readonly kind: TypeKind;
    readonly base: IType;
    constructor(base: IType);
    isSubtypeOf(type: IType): boolean;
    canCoerceFrom(type: IType): boolean;
    getAssignmentType(): IType;
    getCallSignature(): Maybe<ICallSignature>;
    getIndexer(): Maybe<IIndexer>;
    getTypeParameters(): IParametricType[];
    getSuperType(): Maybe<IType>;
    getTracker(): TypeTracker;
    getCoercions(): Set<IType>;
    getSuffixes(): Map<string, IType>;
    getOperator(_: OperatorKind, __?: Maybe<IType>): Maybe<Operator<IType>>;
    getOperators(): Map<OperatorKind, Operator<IType>[]>;
    toString(): string;
    apply(_: IType | Map<IType, IType>): IType;
}
