"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class VariadicType {
    constructor(base) {
        this.base = base;
        this.name = base.name;
        this.access = { get: false, set: false };
        this.kind = 1 /* variadic */;
        this.anyType = false;
    }
    isSubtypeOf(type) {
        return this === type;
    }
    canCoerceFrom(type) {
        return this === type;
    }
    getAssignmentType() {
        return this;
    }
    getCallSignature() {
        return undefined;
    }
    getIndexer() {
        throw undefined;
    }
    getTypeParameters() {
        return [];
    }
    getSuperType() {
        return undefined;
    }
    getTracker() {
        throw new Error('Method not implemented.');
    }
    getCoercions() {
        return new Set();
    }
    getSuffixes() {
        return new Map();
    }
    getOperator(_, __) {
        return undefined;
    }
    getOperators() {
        return new Map();
    }
    toString() {
        return `...${this.base.toString()}`;
    }
    apply(_) {
        return this;
    }
}
exports.VariadicType = VariadicType;
//# sourceMappingURL=variadicType.js.map