"use strict";
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
};
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
const fsUtils_1 = require("./fsUtils");
const fs_1 = require("fs");
const path_1 = require("path");
const vscode_uri_1 = require("vscode-uri");
/**
 * A small set of functionality for loading files and directory of files
 */
class DocumentLoader {
    // private loadDirectoryBound: (path: string) => AsyncIterableIterator<Document>;
    constructor() {
        // this.loadDirectoryBound = this.loadDirectory.bind(this);
    }
    /**
     * Load a file from a given path
     * @param path the system path
     */
    load(path) {
        return fsUtils_1.readFileAsync(path, 'utf-8');
    }
    /**
     * Load a collection of documents from a given directory
     * @param path the path of the directory
     */
    loadDirectory(path) {
        return __asyncGenerator(this, arguments, function* loadDirectory_1() {
            const directoryPaths = fs_1.readdirSync(path);
            for (const directoryPath of directoryPaths) {
                const dirPath = path_1.join(path, directoryPath);
                if (fs_1.statSync(dirPath).isDirectory()) {
                    yield __await(yield* __asyncDelegator(__asyncValues(this.loadDirectory(dirPath))));
                }
                else {
                    if (dirPath.endsWith('.ks')) {
                        yield yield __await({
                            uri: vscode_uri_1.URI.file(dirPath).toString(),
                            text: yield __await(fsUtils_1.readFileAsync(dirPath, 'utf-8')),
                        });
                    }
                }
            }
        });
    }
}
exports.DocumentLoader = DocumentLoader;
//# sourceMappingURL=documentLoader.js.map