"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typeGuards_1 = require("./typeGuards");
/**
 * Generate a mapping function using a provided map object
 * @param map the map to generate the function from
 * @param name the name of the mapping function
 */
exports.mapper = (map, name) => (key) => {
    const value = map.get(key);
    if (typeGuards_1.empty(value)) {
        throw new Error(`No mapping for ${key} in ${name}`);
    }
    return value;
};
//# sourceMappingURL=mapper.js.map